searchNodes=[{"doc":"Defines a quantum Scheduler. When used, the quantum scheduler expects the :otp_app as option. The :otp_app should point to an OTP application that has the quantum runner configuration. For example, the quantum scheduler: defmodule MyApp.Scheduler do use Quantum, otp_app: :my_app end Could be configured with: config :my_app, MyApp.Scheduler, jobs: [ {&quot;@daily&quot;, {Backup, :backup, []}}, ] Configuration: :timeout - Sometimes, you may come across GenServer timeout errors esp. when you have too many jobs or high load. The default GenServer.call timeout is 5000. :jobs - list of cron jobs to execute :schedule - Default schedule of new Job :run_strategy - Default Run Strategy of new Job :overlap - Default overlap of new Job, :timezone - Default timezone of new Job","ref":"Quantum.html","title":"Quantum","type":"behaviour"},{"doc":"Activates a job by name","ref":"Quantum.html#c:activate_job/2","title":"Quantum.activate_job/2","type":"callback"},{"doc":"Adds a new job","ref":"Quantum.html#c:add_job/2","title":"Quantum.add_job/2","type":"callback"},{"doc":"","ref":"Quantum.html#c:config/1","title":"Quantum.config/1","type":"callback"},{"doc":"Deactivates a job by name","ref":"Quantum.html#c:deactivate_job/2","title":"Quantum.deactivate_job/2","type":"callback"},{"doc":"Deletes all jobs","ref":"Quantum.html#c:delete_all_jobs/1","title":"Quantum.delete_all_jobs/1","type":"callback"},{"doc":"Deletes a job by name","ref":"Quantum.html#c:delete_job/2","title":"Quantum.delete_job/2","type":"callback"},{"doc":"Resolves a job by name","ref":"Quantum.html#c:find_job/2","title":"Quantum.find_job/2","type":"callback"},{"doc":"A callback executed when the quantum starts. It takes the quantum configuration that is stored in the application environment, and may change it to suit the application business. It must return the updated list of configuration","ref":"Quantum.html#c:init/1","title":"Quantum.init/1","type":"callback"},{"doc":"Returns the list of currently defined jobs","ref":"Quantum.html#c:jobs/1","title":"Quantum.jobs/1","type":"callback"},{"doc":"Creates a new Job. The job can be added by calling add_job/1.","ref":"Quantum.html#c:new_job/1","title":"Quantum.new_job/1","type":"callback"},{"doc":"Starts supervision and return {:ok, pid} or just :ok if nothing needs to be done. Returns {:error, {:already_started, pid}} if the repo is already started or {:error, term} in case anything else goes wrong. Options See the configuration in the moduledoc for options.","ref":"Quantum.html#c:start_link/1","title":"Quantum.start_link/1","type":"callback"},{"doc":"Shuts down the quantum represented by the given pid.","ref":"Quantum.html#c:stop/2","title":"Quantum.stop/2","type":"callback"},{"doc":"Quantum Scheduler Implementation","ref":"Quantum.html#t:t/0","title":"Quantum.t/0","type":"type"},{"doc":"This Struct defines a Job. Usage The struct should never be defined by hand. Use Quantum.new_job/1 to create a new job and use the setters mentioned below to mutate the job. This is to ensure type safety.","ref":"Quantum.Job.html","title":"Quantum.Job","type":"module"},{"doc":"","ref":"Quantum.Job.html#new/1","title":"Quantum.Job.new/1","type":"function"},{"doc":"Sets a job&#39;s name. Parameters job - The job struct to modify name - The name to set Examples iex&gt; Acme.Scheduler.new_job() ...&gt; |&gt; Quantum.Job.set_name(:name) ...&gt; |&gt; Map.get(:name) :name","ref":"Quantum.Job.html#set_name/2","title":"Quantum.Job.set_name/2","type":"function"},{"doc":"Sets a job&#39;s overlap. Parameters job - The job struct to modify overlap - Enable / Disable Overlap Examples iex&gt; Acme.Scheduler.new_job() ...&gt; |&gt; Quantum.Job.set_overlap(false) ...&gt; |&gt; Map.get(:overlap) false","ref":"Quantum.Job.html#set_overlap/2","title":"Quantum.Job.set_overlap/2","type":"function"},{"doc":"Sets a job&#39;s run strategy. Parameters job - The job struct to modify run_strategy - The run strategy to set Examples iex&gt; Acme.Scheduler.new_job() ...&gt; |&gt; Quantum.Job.run_strategy(%Quantum.RunStrategy.All{nodes: [:one, :two]}) ...&gt; |&gt; Map.get(:run_strategy) [:one, :two]","ref":"Quantum.Job.html#set_run_strategy/2","title":"Quantum.Job.set_run_strategy/2","type":"function"},{"doc":"Sets a job&#39;s schedule. Parameters job - The job struct to modify schedule - The schedule to set. May only be of type %Crontab.CronExpression{} Examples iex&gt; Acme.Scheduler.new_job() ...&gt; |&gt; Quantum.Job.set_schedule(Crontab.CronExpression.Parser.parse!(&quot;*/7&quot;)) ...&gt; |&gt; Map.get(:schedule) Crontab.CronExpression.Parser.parse!(&quot;*/7&quot;)","ref":"Quantum.Job.html#set_schedule/2","title":"Quantum.Job.set_schedule/2","type":"function"},{"doc":"Sets a job&#39;s state. Parameters job - The job struct to modify state - The state to set Examples iex&gt; Acme.Scheduler.new_job() ...&gt; |&gt; Quantum.Job.set_state(:active) ...&gt; |&gt; Map.get(:state) :active","ref":"Quantum.Job.html#set_state/2","title":"Quantum.Job.set_state/2","type":"function"},{"doc":"Sets a job&#39;s task. Parameters job - The job struct to modify task - The function to be performed, ex: {Heartbeat, :send, []} or fn -&gt; :something end Examples iex&gt; Acme.Scheduler.new_job() ...&gt; |&gt; Quantum.Job.set_task({Backup, :backup, []}) ...&gt; |&gt; Map.get(:task) {Backup, :backup, []}","ref":"Quantum.Job.html#set_task/2","title":"Quantum.Job.set_task/2","type":"function"},{"doc":"Sets a job&#39;s timezone. Parameters job - The job struct to modify timezone - The timezone to set. Examples iex&gt; Acme.Scheduler.new_job() ...&gt; |&gt; Quantum.Job.set_timezone(&quot;Europe/Zurich&quot;) ...&gt; |&gt; Map.get(:timezone) &quot;Europe/Zurich&quot;","ref":"Quantum.Job.html#set_timezone/2","title":"Quantum.Job.set_timezone/2","type":"function"},{"doc":"","ref":"Quantum.Job.html#t:name/0","title":"Quantum.Job.name/0","type":"type"},{"doc":"","ref":"Quantum.Job.html#t:schedule/0","title":"Quantum.Job.schedule/0","type":"type"},{"doc":"","ref":"Quantum.Job.html#t:state/0","title":"Quantum.Job.state/0","type":"type"},{"doc":"","ref":"Quantum.Job.html#t:t/0","title":"Quantum.Job.t/0","type":"type"},{"doc":"","ref":"Quantum.Job.html#t:task/0","title":"Quantum.Job.task/0","type":"type"},{"doc":"","ref":"Quantum.Job.html#t:timezone/0","title":"Quantum.Job.timezone/0","type":"type"},{"doc":"Config Normalizer of a Quantum.RunStrategy.NodeList.","ref":"Quantum.RunStrategy.html","title":"Quantum.RunStrategy","type":"behaviour"},{"doc":"Normalize given config to a value that has Quantum.RunStrategy.NodeList implemented. Raise / Do not Match on invalid config.","ref":"Quantum.RunStrategy.html#c:normalize_config!/1","title":"Quantum.RunStrategy.normalize_config!/1","type":"callback"},{"doc":"Run job on all node of the node list If the node list is :cluster, all nodes of the cluster will be used. Mix Configuration config :my_app, MyApp.Scheduler, jobs: [ # Run on all nodes in cluster [schedule: &quot;* * * * *&quot;, run_strategy: {Quantum.RunStrategy.All, :cluster}], # Run on all nodes of given list [schedule: &quot;* * * * *&quot;, run_strategy: {Quantum.RunStrategy.All, [:&quot;node@host1&quot;, :&quot;node@host2&quot;]}], ]","ref":"Quantum.RunStrategy.All.html","title":"Quantum.RunStrategy.All","type":"module"},{"doc":"Run job on local node Mix Configuration config :my_app, MyApp.Scheduler, jobs: [ # Run on local node [schedule: &quot;* * * * *&quot;, run_strategy: Quantum.RunStrategy.Local] ]","ref":"Quantum.RunStrategy.Local.html","title":"Quantum.RunStrategy.Local","type":"module"},{"doc":"Strategy to run Jobs over nodes","ref":"Quantum.RunStrategy.NodeList.html","title":"Quantum.RunStrategy.NodeList","type":"protocol"},{"doc":"Get nodes to run on","ref":"Quantum.RunStrategy.NodeList.html#nodes/2","title":"Quantum.RunStrategy.NodeList.nodes/2","type":"function"},{"doc":"","ref":"Quantum.RunStrategy.NodeList.html#t:t/0","title":"Quantum.RunStrategy.NodeList.t/0","type":"type"},{"doc":"Run job on one node of the list randomly. If the node list is :cluster, one node of the cluster will be used. This run strategy also makes sure, that the node doesn&#39;t run in two places at the same time if job.overlap is falsy. Mix Configuration config :my_app, MyApp.Scheduler, jobs: [ # Run on any node in cluster [schedule: &quot;* * * * *&quot;, run_strategy: {Quantum.RunStrategy.Random, :cluster}], # Run on any node of given list [schedule: &quot;* * * * *&quot;, run_strategy: {Quantum.RunStrategy.Random, [:&quot;node@host1&quot;, :&quot;node@host2&quot;]}], ]","ref":"Quantum.RunStrategy.Random.html","title":"Quantum.RunStrategy.Random","type":"module"},{"doc":"Bahaviour to be implemented by all Storage Adapters. The calls to the storage are blocking, make sure they&#39;re fast to not block the job execution.","ref":"Quantum.Storage.html","title":"Quantum.Storage","type":"behaviour"},{"doc":"Save new job in storage.","ref":"Quantum.Storage.html#c:add_job/2","title":"Quantum.Storage.add_job/2","type":"callback"},{"doc":"Storage child spec If the storage does not need a process, specify a function that returns :ignore. Values :scheduler - The Scheduler","ref":"Quantum.Storage.html#c:child_spec/1","title":"Quantum.Storage.child_spec/1","type":"callback"},{"doc":"Delete new job in storage.","ref":"Quantum.Storage.html#c:delete_job/2","title":"Quantum.Storage.delete_job/2","type":"callback"},{"doc":"Load saved jobs from storage. Returns :not_applicable if the storage has never received an add_job call or after it has been purged. In this case the jobs from the configuration will be loaded.","ref":"Quantum.Storage.html#c:jobs/1","title":"Quantum.Storage.jobs/1","type":"callback"},{"doc":"Load last execution time from storage. Returns :unknown if the storage does not know the last execution time. In this case all jobs will be run at the next applicable date.","ref":"Quantum.Storage.html#c:last_execution_date/1","title":"Quantum.Storage.last_execution_date/1","type":"callback"},{"doc":"Purge all date from storage and go back to initial state.","ref":"Quantum.Storage.html#c:purge/1","title":"Quantum.Storage.purge/1","type":"callback"},{"doc":"Change Job State from given job.","ref":"Quantum.Storage.html#c:update_job_state/3","title":"Quantum.Storage.update_job_state/3","type":"callback"},{"doc":"Update last execution time to given date.","ref":"Quantum.Storage.html#c:update_last_execution_date/2","title":"Quantum.Storage.update_last_execution_date/2","type":"callback"},{"doc":"The location of the server. Values nil if the storage was not started server() if the storage was started","ref":"Quantum.Storage.html#t:storage_pid/0","title":"Quantum.Storage.storage_pid/0","type":"type"},{"doc":"Empty implementation of a Quantum.Storage.","ref":"Quantum.Storage.Noop.html","title":"Quantum.Storage.Noop","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Quantum.Storage.Noop.html#child_spec/1","title":"Quantum.Storage.Noop.child_spec/1","type":"function"},{"doc":"Quantum Cron-like job scheduler for Elixir. This README follows master, which may not be the currently published version. Here are the docs for the latest published version of Quantum.","ref":"readme.html","title":"Quantum","type":"extras"},{"doc":"To use Quantum in your project, edit the mix.exs file and add Quantum to 1. the list of dependencies: defp deps do [{:quantum, &quot;~&gt; 3.0&quot;}] end 2. and create a scheduler for your app: defmodule Acme.Scheduler do use Quantum, otp_app: :your_app end 3. and your application&#39;s supervision tree: defmodule Acme.Application do use Application def start(_type, _args) do import Supervisor.Spec, warn: false children = [ # This is the new line Acme.Scheduler ] opts = [strategy: :one_for_one, name: Acme.Supervisor] Supervisor.start_link(children, opts) end end","ref":"readme.html#setup","title":"Quantum - Setup","type":"extras"},{"doc":"To see more transparently what quantum is doing, configure the logger to display :debug messages. config :logger, level: :debug If you want do use the logger in debug-level without the messages from quantum: config :acme, Acme.Scheduler, debug_logging: false If you encounter any problems with quantum, please search if there is already an open issue addressing the problem. Otherwise feel free to open an issue. Please include debug logs.","ref":"readme.html#troubleshooting","title":"Quantum - Troubleshooting","type":"extras"},{"doc":"Configure your cronjobs in your config/config.exs like this: config :acme, Acme.Scheduler, jobs: [ # Every minute {&quot;* * * * *&quot;, {Heartbeat, :send, []}}, # Every 15 minutes {&quot;*/15 * * * *&quot;, fn -&gt; System.cmd(&quot;rm&quot;, [&quot;/tmp/tmp_&quot;]) end}, # Runs on 18, 20, 22, 0, 2, 4, 6: {&quot;0 18-6/2 * * *&quot;, fn -&gt; :mnesia.backup(&#39;/var/backup/mnesia&#39;) end}, # Runs every midnight: {&quot;@daily&quot;, {Backup, :backup, []}} ] More details on the usage can be found in the Documentation","ref":"readme.html#usage","title":"Quantum - Usage","type":"extras"},{"doc":"This project uses the Collective Code Construction Contract (C4) for all code changes. &quot;Everyone, without distinction or discrimination, SHALL have an equal right to become a Contributor under the terms of this contract.&quot; tl;dr Check for open issues or open a new issue to start a discussion around a problem. Issues SHALL be named as &quot;Problem: description of the problem&quot;. Fork the quantum-elixir repository on GitHub to start making your changes If possible, write a test which shows that the problem was solved. Send a pull request. Pull requests SHALL be named as &quot;Solution: description of your solution&quot; Your pull request is merged and you are added to the list of contributors Code Contributors This project exists thanks to all the people who contribute. Financial Contributors Become a financial contributor and help us sustain our community. [Contribute] Individuals Organizations Support this project with your organization. Your logo will show up here with a link to your website. [Contribute]","ref":"readme.html#contribution","title":"Quantum - Contribution","type":"extras"},{"doc":"Apache License, Version 2.0","ref":"readme.html#license","title":"Quantum - License","type":"extras"},{"doc":"Change Log All notable changes to this project will be documented in this file. This project adheres to Semantic Versioning.","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"Diff for unreleased","ref":"changelog.html#unreleased","title":"Change Log - Unreleased","type":"extras"},{"doc":"Fixed ClockEvent order corrected Diff for 3.0.1","ref":"changelog.html#3-0-1-2020-06-16","title":"Change Log - 3.0.1 - 2020-06-16","type":"extras"},{"doc":"Fixed Fix @reboot Cron Expression (#437) Diff for 3.0.0","ref":"changelog.html#3-0-0-2020-06-11","title":"Change Log - 3.0.0 - 2020-06-11","type":"extras"},{"doc":"Fixed Update Docs Diff for 3.0.0-rc.3","ref":"changelog.html#3-0-0-rc-3-2020-02-28","title":"Change Log - 3.0.0-rc.3 - 2020-02-28","type":"extras"},{"doc":"Changed The Quantum.Storage behaviour contains a new mandatory child_spec/1 callback. Diff for 3.0.0-rc.2","ref":"changelog.html#3-0-0-rc-2-2020-02-28","title":"Change Log - 3.0.0-rc.2 - 2020-02-28","type":"extras"},{"doc":"","ref":"changelog.html#3-0-0-rc-1-2020-02-26","title":"Change Log - 3.0.0-rc.1 - 2020-02-26","type":"extras"},{"doc":"A lot of function that were not for public use have been undocumented. Those are now considered internal and may break at any point in time. Quantum.Scheduler has been renamed to Quantum Quantum.Storage.Adapter has been renamed to Quantum.Storage The global mode has been removed. It will be reimplemented if a stable replacement is found. Diff for 3.0.0-rc.1","ref":"changelog.html#changed","title":"Change Log - Changed","type":"extras"},{"doc":"Added Native Date Library (via #405) Adding of inactive Jobs (via #409) Fixed GenStage 1.0 compatibility (via #424) Doc Fixes (#394, #396, #400, #401) Diff for 2.4.0","ref":"changelog.html#2-4-0-2020-02-25","title":"Change Log - 2.4.0 - 2020-02-25","type":"extras"},{"doc":"Fixed Faster Startup duration for non-global (Fixes #376) Diff for 2.3.4","ref":"changelog.html#2-3-4-2019-01-06","title":"Change Log - 2.3.4 - 2019-01-06","type":"extras"},{"doc":"Fixed Fix &amp; Test Swarm Handoff &amp; Conflict Resolution Fix Compilation Error Fix Executor Stat Options for GenStage ~&gt; 0.12.0 Diff for 2.3.3","ref":"changelog.html#2-3-3-2018-09-06","title":"Change Log - 2.3.3 - 2018-09-06","type":"extras"},{"doc":"Fixed Global Clustering Worker Start Diff for 2.3.2","ref":"changelog.html#2-3-2-2018-08-21","title":"Change Log - 2.3.2 - 2018-08-21","type":"extras"},{"doc":"Fixed Fixed Regression in Run Strategy Random Diff for 2.3.1","ref":"changelog.html#2-3-1-2018-08-13","title":"Change Log - 2.3.1 - 2018-08-13","type":"extras"},{"doc":"Added Experimental Storage API Fixed Use Swarm for clustering to prevent broken cluster state Better search for available nodes for run strategies Diff for 2.3.0","ref":"changelog.html#2-3-0-2018-08-10","title":"Change Log - 2.3.0 - 2018-08-10","type":"extras"},{"doc":"Changed Moved the Repository into Organization &amp; Correct all the URL&#39;s Fixed Fixed Dialyzer Warnings Diff for 2.2.7","ref":"changelog.html#2-2-7-2018-03-22","title":"Change Log - 2.2.7 - 2018-03-22","type":"extras"},{"doc":"Fixed Fixed problem with Daylight Saving Time for jobs with timezone other than UTC. Diff for 2.2.6","ref":"changelog.html#2-2-6-2018-03-21","title":"Change Log - 2.2.6 - 2018-03-21","type":"extras"},{"doc":"Fixed Omit gen_stage warning on ~&gt; 0.13 Diff for 2.2.5","ref":"changelog.html#2-2-5-2018-02-26","title":"Change Log - 2.2.5 - 2018-02-26","type":"extras"},{"doc":"Fixed Relax timex dependency Diff for 2.2.4","ref":"changelog.html#2-2-4-2018-02-23","title":"Change Log - 2.2.4 - 2018-02-23","type":"extras"},{"doc":"Fixed Fixed compatibility with gen_stage ~&gt; 0.12 Diff for 2.2.3","ref":"changelog.html#2-2-3-2018-02-13","title":"Change Log - 2.2.3 - 2018-02-13","type":"extras"},{"doc":"Added Better Debugging Capabilities Fixed Relaxed version requirements for gen_stage Diff for 2.2.2","ref":"changelog.html#2-2-2-2018-02-08","title":"Change Log - 2.2.2 - 2018-02-08","type":"extras"},{"doc":"Fixed sometimes the task supervisor was not running in a cluster Diff for 2.2.1","ref":"changelog.html#2-2-1-2018-01-03","title":"Change Log - 2.2.1 - 2018-01-03","type":"extras"},{"doc":"Diff for 2.2.0 Added Local run strategy","ref":"changelog.html#2-2-0-2017-11-07","title":"Change Log - 2.2.0 - 2017-11-07","type":"extras"},{"doc":"Diff for 2.1.3 Fixed Runtime Added Jobs are executed right away instead of waiting for the next job execution. Fix Typo in Doc","ref":"changelog.html#2-1-3-2017-11-07","title":"Change Log - 2.1.3 - 2017-11-07","type":"extras"},{"doc":"Diff for 2.1.2 Added Distillery is not mentioned in list of package managers Changed Source is not formatted properly Fixed Removed unused Alias from Quantum.Job Hot upgrade is not possible due to missing supervisor","ref":"changelog.html#2-1-2-2017-11-04","title":"Change Log - 2.1.2 - 2017-11-04","type":"extras"},{"doc":"Diff for 2.1.1 Fixed Resolved some Dialyzer Warnings","ref":"changelog.html#2-1-1-2017-10-02","title":"Change Log - 2.1.1 - 2017-10-02","type":"extras"},{"doc":"Diff for 2.1.0 Fixed Resolved some Dialyzer Warnings","ref":"changelog.html#2-1-0-2017-09-10","title":"Change Log - 2.1.0 - 2017-09-10","type":"extras"},{"doc":"Diff for 2.1.0-beta.1 The internal handling has been refactored onto gen_stage. There were a few Breaking Changes which should not influence a user of the library. Changed Replaced call with cast Scheduler.add_job Scheduler.deactivate_job Scheduler.activate_job Scheduler.delete_job Scheduler.delete_all_jobs Removed The overlap handling is removed from the Job struct. removed Job.pids removed Job.executable?","ref":"changelog.html#2-1-0-beta-1-2017-08-20","title":"Change Log - 2.1.0-beta.1 - 2017-08-20","type":"extras"},{"doc":"Diff for 2.0.4 Fixed Fix Race Condition with reboot in Runner state","ref":"changelog.html#2-0-4-2017-09-01","title":"Change Log - 2.0.4 - 2017-09-01","type":"extras"},{"doc":"Diff for 2.0.3 Fixed @reboot cron expressions","ref":"changelog.html#2-0-3-2017-08-29","title":"Change Log - 2.0.3 - 2017-08-29","type":"extras"},{"doc":"Diff for 2.0.2 Fixed Updated Docs.","ref":"changelog.html#2-0-2-2017-08-23","title":"Change Log - 2.0.2 - 2017-08-23","type":"extras"},{"doc":"Diff for 2.0.1 Timezone in job configuration is now normalized into a job.","ref":"changelog.html#2-0-1-2017-08-23","title":"Change Log - 2.0.1 - 2017-08-23","type":"extras"},{"doc":"Diff for 2.0.0 The whole library has been refactored. See the Migration Guide.","ref":"changelog.html#2-0-0-2017-07-20","title":"Change Log - 2.0.0 - 2017-07-20","type":"extras"},{"doc":"Diff for 2.0.0-beta.2 The whole library has been refactored. See the Migration Guide.","ref":"changelog.html#2-0-0-beta-2-2017-07-13","title":"Change Log - 2.0.0-beta.2 - 2017-07-13","type":"extras"},{"doc":"Diff for 2.0.0-beta.1 The whole library has been refactored. See the Migration Guide.","ref":"changelog.html#2-0-0-beta-1-2017-06-07","title":"Change Log - 2.0.0-beta.1 - 2017-06-07","type":"extras"},{"doc":"Diff for 1.9.2","ref":"changelog.html#1-9-2-2017-05-19","title":"Change Log - 1.9.2 - 2017-05-19","type":"extras"},{"doc":"Diff for 1.9.1","ref":"changelog.html#1-9-1-2017-03-17","title":"Change Log - 1.9.1 - 2017-03-17","type":"extras"},{"doc":"Diff for 1.9.0 Removed Three modules were removed and replaced by crontab. Quantum.Matcher Quantum.Parser Quantum.Translator Fixed The whole cron expression syntax is now supported. Crons can now be configured for Umbrella applications. See the README for the new syntax. Changed Cron Expressions can now be provided via the %Crontab.CronExpression{} struct or via the ~e[CRON EXPRESSION] sigil. Cron Expressions can now be extended. This way second granularity of the expressions can be provided. Deprecated The configuration property cron is deprecated. Use the app configuration instead.","ref":"changelog.html#1-9-0-2017-02-07","title":"Change Log - 1.9.0 - 2017-02-07","type":"extras"},{"doc":"Diff for 1.8.1 Changed Clarity on the table to not use full name of day (Coburn Berry) Travis testing against erlang 19.1 and elixir 1.3.3 (Julius Beckmann) Don&#39;t allow &quot;local&quot; timezone. Replace Timex w. Calendar (Lau Taarnskov) Fixed Global cannot be used directly (Po Chen) Support for timezones other than utc or local not in readme (Coburn Berry) Timezone as string not working in config (Daniel Roux) Removed Timex references in readme (Coburn Berry) License badge in README","ref":"changelog.html#1-8-1-2016-11-20","title":"Change Log - 1.8.1 - 2016-11-20","type":"extras"},{"doc":"Diff for 1.8.0 Changed Requires Elixir &gt;= 1.3 Updated C4 contribution process to RFC42 Updated timex dependency to 3.0 (Svilen Gospodinov) Fixed Same task could be generated multiple times in a cluster (Po Chen) Elixir 1.3.0 introduced unsafe var warnings (Jamie J Quinn) Typo in README (Uģis Ozols) Code coverage below 100% (Lucas Charles) Removed Unused alias (Philip Giuliani)","ref":"changelog.html#1-8-0-2016-09-19","title":"Change Log - 1.8.0 - 2016-09-19","type":"extras"},{"doc":"Diff for 1.7.1 Added Optional per-job timezone support Fixed Nodes defaulting in %Quantum.Job struct job.nodes defaulting in the normalizer Test suite after changing defaulting of nodes property for the %Quantum.Jobs{} struct","ref":"changelog.html#1-7-1-2016-03-24","title":"Change Log - 1.7.1 - 2016-03-24","type":"extras"},{"doc":"Diff for 1.7.0 Added ToC to README Documentation for overlap option Elixir 1.2 to Travis-CI config Prevent duplicate job-names at runtime (Kai Faber) Changed ToC markdown Default values are now configurable Updated all dependencies Required Elixir version is now &gt;= 1.2 Fixed Overlap option was not set to jobs Incorrect example in README Timezone is not configurable at runtime Credo warnings GenServer restarts when one of the jobs crashes (#82)","ref":"changelog.html#1-7-0-2016-03-09","title":"Change Log - 1.7.0 - 2016-03-09","type":"extras"},{"doc":"Diff for 1.6.1 Fixed @reboot entries are throwing errors Credo warnings and software design suggestions Elixir 1.2 warnings Changed Dependency &#39;credo&#39; updated Refactored range variables .gitignore updated","ref":"changelog.html#1-6-1-2015-12-09","title":"Change Log - 1.6.1 - 2015-12-09","type":"extras"},{"doc":"Diff for 1.6.0 Added PID of last executed task to job struct Credo code linter (only for dev and test) Total downloads badge to README Elixir 1.1.0 and Erlang 18.1 to Travis-CI config Fixed Max hour is 23, not 24 Long-running jobs could overlap Typo in README (Lucas Charles) Incorrect function and response types in readme (Bart van Zon) Unnamed job tuples cannot take args (Lucas Charles) Job names can only be atoms and can&#39;t be GC (Luis Hurtado)","ref":"changelog.html#1-6-0-2015-11-25","title":"Change Log - 1.6.0 - 2015-11-25","type":"extras"},{"doc":"Diff for 1.5.0 Added Ability to run jobs on exact node (Rodion Vshevtsov) Documentation of named jobs OTP 17.5 and 18.0 to Travis tests Changed ex_doc dependency version Fixed Typos in README","ref":"changelog.html#1-5-0-2015-09-24","title":"Change Log - 1.5.0 - 2015-09-24","type":"extras"},{"doc":"Diff for 1.4.0 Added Named jobs and the ability to (de)activate them (Rodion Vshevtsov) Doc annotations for functions Inch-CI integration Changed Updated ex_doc dependency","ref":"changelog.html#1-4-0-2015-09-02","title":"Change Log - 1.4.0 - 2015-09-02","type":"extras"},{"doc":"Diff for 1.3.2 Added Timezone option to README. Fixed Using @reboot lead to crash.","ref":"changelog.html#1-3-2-2015-08-22","title":"Change Log - 1.3.2 - 2015-08-22","type":"extras"},{"doc":"Diff for 1.3.1 Added Added contributors to changelog and project description Option to use local timezone instead of UTC. Changed Tables in README use markdown format","ref":"changelog.html#1-3-1-2015-07-27","title":"Change Log - 1.3.1 - 2015-07-27","type":"extras"},{"doc":"Diff for 1.3.0 Added Allow cron-like job formatting (&quot;* * * * * MyApp.MyModule.my_method&quot;) (Rodion Vshevtsov) Allow defining functions as tuple ({&quot;Module&quot;, :method}) in config (Rodion Vshevtsov) Note about UTC (Lenz Gschwendtner)","ref":"changelog.html#1-3-0-2015-07-15","title":"Change Log - 1.3.0 - 2015-07-15","type":"extras"},{"doc":"Diff for 1.2.4 Changed Renamed parse/5 functions to do_parse/5 and made them private Always use {expression, fun} for jobs Moved duplicate code to new private function only_multiplier_of/2 Moved code to normalize jobs to separate module Correctly use passed state in Quantum.init/1 function Moved reboot logic to executor. Removed Unnecessary guard clause Unused parse/3 functions Unused call to String.split on patterns starting with &quot;*/&quot;","ref":"changelog.html#1-2-4-2015-06-22","title":"Change Log - 1.2.4 - 2015-06-22","type":"extras"},{"doc":"Diff for 1.2.3 Added Support for @reboot Fixed Does not convert jobs defined in config","ref":"changelog.html#1-2-3-2015-06-15","title":"Change Log - 1.2.3 - 2015-06-15","type":"extras"},{"doc":"Diff for 1.2.2 Added Support for @annually and @midnight Changed Function order in Quantum.Matcher Renamed private translate function to do_translate Do not convert and translate cron expressions on every tick Fixed Adding a job using Quantum.add_job/2 does not convert to lowercase Adding a job using Quantum.add_job/2 does not translate day/month names","ref":"changelog.html#1-2-2-2015-06-15","title":"Change Log - 1.2.2 - 2015-06-15","type":"extras"},{"doc":"Diff for 1.2.1 Added Test for handle_info(:tick_state) Dependencies to generate hexdocs Badge for hexdocs Link to docs in hex package info Type specs and doc annotations Changed Quantum.Application does not call Quantum.start_link/1 anymore Moved match logic to separate module Quantum.Matcher Moved parsing logic to separate module Quantum.Parser Moved execution logic to separate module Quantum.Executor Moved translation logic to separate module Quantum.Translator Fixed Typos in changelog Removed Quantum.start_link/1","ref":"changelog.html#1-2-1-2015-06-13","title":"Change Log - 1.2.1 - 2015-06-13","type":"extras"},{"doc":"Diff for 1.2.0 Changed Date is updated in state only if it changed Wake up every minute instead of every second Fixed Intervals on ranges are not correctly parsed Hour constraints are not correct (Lenz Gschwendtner) There is no changelog Code coverage is low Explicit variables are not needed Pattern matching can be simplified","ref":"changelog.html#1-2-0-2015-06-11","title":"Change Log - 1.2.0 - 2015-06-11","type":"extras"},{"doc":"Diff for 1.1.0 Added Add ability to schedule jobs at runtime and ability to view jobs (Dan Swain) Changed Relax Elixir version","ref":"changelog.html#1-1-0-2015-05-28","title":"Change Log - 1.1.0 - 2015-05-28","type":"extras"},{"doc":"Diff for 1.0.4 Fixed Written month and weekday names are not parsed","ref":"changelog.html#1-0-4-2015-05-26","title":"Change Log - 1.0.4 - 2015-05-26","type":"extras"},{"doc":"Diff for 1.0.3 Fixed Do not fire on first tick","ref":"changelog.html#1-0-3-2015-05-01","title":"Change Log - 1.0.3 - 2015-05-01","type":"extras"},{"doc":"Diff for 1.0.2 Fixed Special expressions are not correctly in all cases Removed Functions to add and reset jobs","ref":"changelog.html#1-0-2-2015-04-29","title":"Change Log - 1.0.2 - 2015-04-29","type":"extras"},{"doc":"Diff for 1.0.1 Added Configure cronjobs in config Add application Fixed Parsing of cron expression fails","ref":"changelog.html#1-0-1-2015-04-27","title":"Change Log - 1.0.1 - 2015-04-27","type":"extras"},{"doc":"Diff for 1.0.0 Added Initial commit","ref":"changelog.html#1-0-0-2015-04-27","title":"Change Log - 1.0.0 - 2015-04-27","type":"extras"},{"doc":"Supervision Tree YourApp.Scheduler (Quantum) - Your primary Interface to interact with. (Like add_job/1 etc.) YourApp.Scheduler.Supervisor (Quantum.Supervisor) - The Supervisor that coordinates configuration, the runner and task supervisor. YourApp.Scheduler.TaskRegistry (Quantum.TaskRegistry) - The GenServer that keeps track of running tasks and prevents overlap. YourApp.Scheduler.JobBroadcaster (Quantum.JobBroadcaster) - The GenStage that keeps track of all jobs. YourApp.Scheduler.ExecutionBroadcaster (Quantum.ExecutionBroadcaster) - The GenStage that notifies execution of jobs. YourApp.Scheduler.ExecutorSupervisor (Quantum.ExecutorSupervisor) - The ConsumerSupervisor that spawns an Executor for every execution. no_name (YourApp.Scheduler.Executor) - The Task that calls the YourApp.Scheduler.Task.Supervisor with the execution of the cron (per Node). YourApp.Scheduler.Task.Supervisor (Task.Supervisor) - The Task.Supervisor where all cron jobs run in. Task - The place where the defined cron job action gets called.","ref":"supervision-tree.html","title":"Supervision Tree","type":"extras"},{"doc":"The OTP Supervision Tree is initiated by the user of the library. Therefore the error handling can be implemented via normal OTP means. See Supervisor.Spec for more information.","ref":"supervision-tree.html#error-handling","title":"Supervision Tree - Error Handling","type":"extras"},{"doc":"Configuration Configure your cronjobs in your config/config.exs like this: config :your_app, YourApp.Scheduler, jobs: [ # Every minute {&quot;* * * * *&quot;, {Heartbeat, :send, []}}, {{:cron, &quot;* * * * *&quot;}, {Heartbeat, :send, []}}, # Every second {{:extended, &quot;* * * * *&quot;}, {Heartbeat, :send, []}}, # Every 15 minutes {&quot;*/15 * * * *&quot;, fn -&gt; System.cmd(&quot;rm&quot;, [&quot;/tmp/tmp_&quot;]) end}, # Runs on 18, 20, 22, 0, 2, 4, 6: {&quot;0 18-6/2 * * *&quot;, fn -&gt; :mnesia.backup(&#39;/var/backup/mnesia&#39;) end}, # Runs every midnight: {&quot;@daily&quot;, {Backup, :backup, []}} ]","ref":"configuration.html","title":"Configuration","type":"extras"},{"doc":"Persistent storage can be used to track jobs and last execution times over restarts. Note: If a storage is present, the jobs from the configuration will not be loaded to prevent conflicts. config :your_app, YourApp.Scheduler, storage: Quantum.Storage.Implementation Storage Adapters Storage implementations must implement the Quantum.Storage behaviour. The following adapters are supported: PersistentEts Mnesia","ref":"configuration.html#persistent-storage","title":"Configuration - Persistent Storage","type":"extras"},{"doc":"( conform / distillery / exrm / edeliver ) Please note that the following config notation is not supported by release managers. {&quot;* * * * *&quot;, fn -&gt; :anonymous_function end}","ref":"configuration.html#release-managers","title":"Configuration - Release managers","type":"extras"},{"doc":"You can define named jobs in your config like this: config :your_app, YourApp.Scheduler, jobs: [ news_letter: [ schedule: &quot;@weekly&quot;, task: {Heartbeat, :send, [:arg1]}, ] ] Possible options: schedule cron schedule, ex: &quot;@weekly&quot; / &quot;1 * * * *&quot; / {:cron, &quot;1 * * * *&quot;} or {:extended, &quot;1 * * * *&quot;} task function to be performed, ex: {Heartbeat, :send, []} or fn -&gt; :something end run_strategy strategy on how to run tasks inside of cluster, default: %Quantum.RunStrategy.Random{nodes: :cluster} overlap set to false to prevent next job from being executed if previous job is still running, default: true It is possible to control the behavior of jobs at runtime.","ref":"configuration.html#named-jobs","title":"Configuration - Named Jobs","type":"extras"},{"doc":"The default job settings can be configured as shown in the example below. So if you have a lot of jobs and do not want to override the default setting in every job, you can set them globally. config :your_app, YourApp.Scheduler, schedule: &quot;* * * * *&quot;, overlap: false, timezone: :utc, jobs: [ # Your cronjobs ]","ref":"configuration.html#override-default-settings","title":"Configuration - Override default settings","type":"extras"},{"doc":"It is possible to specify jobs with second granularity. To do this the schedule parameter has to be provided with a {:extended, &quot;1 * * * *&quot;} expression. config :your_app, YourApp.Scheduler, jobs: [ news_letter: [ schedule: {:extended, &quot;*/2&quot;}, # Runs every two seconds task: {Heartbeat, :send, [:arg1]} ] ]","ref":"configuration.html#jobs-with-second-granularity","title":"Configuration - Jobs with Second granularity","type":"extras"},{"doc":"Sometimes, you may come across GenServer timeout errors esp. when you have too many jobs or high load. The default GenServer.call timeout is 5000. You can override this default by specifying timeout setting in configuration. config :your_app, YourApp.Scheduler, timeout: 30_000 Or if you wish to wait indefinitely: config :your_app, YourApp.Scheduler, timeout: :infinity","ref":"configuration.html#genserver-timeout","title":"Configuration - GenServer timeout","type":"extras"},{"doc":"Please note that Quantum uses UTC timezone and not local timezone. Before changing the timezone you need to install Tzdata and add the following line in your config file. config :elixir, :time_zone_database, Tzdata.TimeZoneDatabase Now you can specify another default timezone, add the following timezone option to your configuration: config :your_app, YourApp.Scheduler, timezone: &quot;America/Chicago&quot;, jobs: [ # Your cronjobs ] Valid options are :utc or a timezone name such as &quot;America/Chicago&quot;. A full list of timezone names can be downloaded from https://www.iana.org/time-zones, or at https://en.wikipedia.org/wiki/List_of_tz_database_time_zones. Timezones can also be configured on a per-job basis. This overrides the default Quantum timezone for a particular job. To set the timezone on a job, use the timezone key when creating the Quantum.Job structure. %Quantum.Job{ # ... timezone: &quot;America/New_York&quot; }","ref":"configuration.html#timezone-support","title":"Configuration - Timezone Support","type":"extras"},{"doc":"Runtime Configuration If you want to add jobs on runtime, this is possible too: import Crontab.CronExpression YourApp.Scheduler.add_job({~e[1 * * * *], fn -&gt; :ok end}) Add a named job at runtime: import Crontab.CronExpression YourApp.Scheduler.new_job() |&gt; Quantum.Job.set_name(:ticker) |&gt; Quantum.Job.set_schedule(~e[1 * * * *]) |&gt; Quantum.Job.set_task(fn -&gt; :ok end) |&gt; YourApp.Scheduler.add_job() Deactivate a job, i.e. it will not be performed until job is activated again: YourApp.Scheduler.deactivate_job(:ticker) Activate an inactive job: YourApp.Scheduler.activate_job(:ticker) Find a job: YourApp.Scheduler.find_job(:ticker) # %Quantum.Job{...} Delete a job: YourApp.Scheduler.delete_job(:ticker) # %Quantum.Job{...}","ref":"runtime.html","title":"Runtime Configuration","type":"extras"},{"doc":"It is possible to specify jobs with second granularity. To do this the schedule parameter has to be provided with either a %Crontab.CronExpression{extended: true, ...} or with a set e flag on the e sigil. (The sigil must be imported from Crontab.CronExpression) The following example will put a tick into the stdout every second. import Crontab.CronExpression YourApp.Scheduler.new_job() |&gt; Quantum.Job.set_name(:ticker) |&gt; Quantum.Job.set_schedule(~e[1 * * * *]e) |&gt; Quantum.Job.set_task(fn -&gt; IO.puts &quot;tick&quot; end) |&gt; YourApp.Scheduler.add_job()","ref":"runtime.html#jobs-with-second-granularity","title":"Runtime Configuration - Jobs with Second granularity","type":"extras"},{"doc":"Crontab format","ref":"crontab-format.html","title":"Crontab format","type":"extras"},{"doc":"FieldAllowed values second0-59 minute0-59 hour0-23 day of month1-31 month1-12 (or names) day of week0-6 (0 is Sunday, or use abbreviated names) The second field can only be used in extended cron expressions. Names can also be used for the month and day of week fields. Use the first three letters of the particular day or month (case does not matter).","ref":"crontab-format.html#basics","title":"Crontab format - Basics","type":"extras"},{"doc":"Instead of the first five fields, one of these special strings may be used: StringDescription @annuallyRun once a year, same as ~e[&quot;0 0 1 1 *&quot;] or @yearly @dailyRun once a day, same as ~e[&quot;0 0 * * *&quot;] or @midnight @hourlyRun once an hour, same as ~e[&quot;0 * * * *&quot;] @midnightRun once a day, same as ~e[&quot;0 0 * * *&quot;] or @daily @minutelyRun once a minute, same as ~e[&quot;* * * * *&quot;] @monthlyRun once a month, same as ~e[&quot;0 0 1 * *&quot;] @rebootRun once, at startup @secondlyRun once a second, same as ~e[&quot;* * * * * *&quot;]e @weeklyRun once a week, same as ~e[&quot;0 0 * * 0&quot;] @yearlyRun once a year, same as ~e[&quot;0 0 1 1 *&quot;] or @annually","ref":"crontab-format.html#special-expressions","title":"Crontab format - Special expressions","type":"extras"},{"doc":"Oracle Cron Format Wikipedia","ref":"crontab-format.html#supported-notations","title":"Crontab format - Supported Notations","type":"extras"},{"doc":"All Cron Expressions are parsed and evaluated by crontab. Issues with parsing a cron expression can be reported here: crontab GitHub issues","ref":"crontab-format.html#crontab-dependency","title":"Crontab format - Crontab Dependency","type":"extras"},{"doc":"Run Strategies Tasks can be executed via different run strategies.","ref":"run-strategies.html","title":"Run Strategies","type":"extras"},{"doc":"Mix config :my_app, MyApp.Scheduler, jobs: [ [schedule: &quot;* * * * *&quot;, run_strategy: {StrategyName, options}], ] The run strategy can be configured by providing a tuple of the strategy module name and it&#39;s options. If you choose Local Node strategy, the config should be: config :my_app, MyApp.Scheduler, jobs: [ [schedule: &quot;* * * * *&quot;, run_strategy: Quantum.RunStrategy.Local], ] Runtime Provide a value that implements the Quantum.RunStrategy.NodeList protocol. The value will not be normalized.","ref":"run-strategies.html#configuration","title":"Run Strategies - Configuration","type":"extras"},{"doc":"All Nodes Quantum.RunStrategy.All If you want to run a task on all nodes of either a list or in the whole cluster, use this strategy. Random Node Quantum.RunStrategy.Random If you want to run a task on any node of either a list or in the whole cluster, use this strategy. Local Node Quantum.RunStrategy.Local If you want to run a task on local node, use this strategy.","ref":"run-strategies.html#provided-strategies","title":"Run Strategies - Provided Strategies","type":"extras"},{"doc":"Custom run strategies, can be implemented by implementing the Quantum.RunStrategy behaviour and the Quantum.RunStrategy.NodeList protocol.","ref":"run-strategies.html#custom-run-strategy","title":"Run Strategies - Custom Run Strategy","type":"extras"}]